> ## Documentation Index
> Fetch the complete documentation index at: https://docs.compasslabs.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Open a new LP position

> This endpoint allows users to open a new Liquidity Provider (LP) position on the
Uniswap platform.

By providing the necessary parameters, users can initiate a minting process to
create a new LP token, which represents their stake in a specific liquidity pool.
This operation is essential for users looking to participate in liquidity provision,
enabling them to earn fees from trades that occur within the pool. The endpoint
requires details such as the token pair, amount, and any additional parameters
needed for the minting process.
                    <Info>
                    **Required Allowances**

                        In order to make this transaction, token allowances need to be set for the following contracts.

                     - `UniswapV3NFTPositionManager`
                    </Info>
                



## OpenAPI

````yaml /v1/combined_spec.json post /v1/uniswap/liquidity_provision/mint
openapi: 3.1.0
info:
  title: Compass API
  description: Compass Labs DeFi API
  version: 0.0.1
servers:
  - url: https://api.compasslabs.ai
    description: Production server
security:
  - ApiKeyAuth: []
paths:
  /v1/uniswap/liquidity_provision/mint:
    post:
      tags:
        - Uniswap V3
      summary: Open a new LP position
      description: >-
        This endpoint allows users to open a new Liquidity Provider (LP)
        position on the

        Uniswap platform.


        By providing the necessary parameters, users can initiate a minting
        process to

        create a new LP token, which represents their stake in a specific
        liquidity pool.

        This operation is essential for users looking to participate in
        liquidity provision,

        enabling them to earn fees from trades that occur within the pool. The
        endpoint

        requires details such as the token pair, amount, and any additional
        parameters

        needed for the minting process.
                            <Info>
                            **Required Allowances**

                                In order to make this transaction, token allowances need to be set for the following contracts.

                             - `UniswapV3NFTPositionManager`
                            </Info>
                        
      operationId: v1_uniswap_liquidity_provision_mint
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/UniswapMintLiquidityProvisionRequest'
        required: true
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/TransactionResponse'
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      x-codeSamples:
        - lang: python
          label: Python (SDK)
          source: |-
            from compass_api_sdk import CompassAPI, models


            with CompassAPI(
                api_key_auth="<YOUR_API_KEY_HERE>",
            ) as compass_api:

                res = compass_api.uniswap_v3.uniswap_liquidity_provision_mint(token0="USDC", token1="USDT", fee=models.FeeEnum.ONE_DOT_0, tick_lower=1823, tick_upper=2623, amount0_desired="0.05", amount1_desired="0.00", amount0_min="0", amount1_min="0", chain=models.UniswapMintLiquidityProvisionRequestChain.BASE, sender="0x41096de529D54718a5600185F8C4460979ed75C9", recipient="0x41096de529D54718a5600185F8C4460979ed75C9", estimate_gas=True)

                # Handle response
                print(res)
        - lang: typescript
          label: Typescript (SDK)
          source: |-
            import { CompassApiSDK } from "@compass-labs/api-sdk";

            const compassApiSDK = new CompassApiSDK({
              apiKeyAuth: "<YOUR_API_KEY_HERE>",
            });

            async function run() {
              const result = await compassApiSDK.uniswapV3.uniswapLiquidityProvisionMint({
                token0: "USDC",
                token1: "USDT",
                fee: "1.0",
                tickLower: 1823,
                tickUpper: 2623,
                amount0Desired: "0.05",
                amount1Desired: "0.00",
                amount0Min: "0",
                amount1Min: "0",
                recipient: "0x41096de529D54718a5600185F8C4460979ed75C9",
                chain: "base",
                sender: "0x41096de529D54718a5600185F8C4460979ed75C9",
              });

              console.log(result);
            }

            run();
components:
  schemas:
    UniswapMintLiquidityProvisionRequest:
      properties:
        action_type:
          type: string
          const: UNISWAP_MINT_LIQUIDITY_PROVISION
          title: Action Type
          default: UNISWAP_MINT_LIQUIDITY_PROVISION
        token0:
          type: string
          title: Token
          description: The symbol or address of the first token in the pair.
          examples:
            - WETH
          default: USDC
        token1:
          type: string
          title: Token
          description: The symbol or address of the second token in the pair.
          examples:
            - WETH
          default: USDT
        fee:
          $ref: '#/components/schemas/FeeEnum'
          description: The swap fee of the pool
          examples:
            - '0.3'
          default: '1.0'
        tick_lower:
          type: integer
          maximum: 887272
          minimum: -887272
          title: Tick Lower
          description: The lower tick of the range to mint the position in
          examples:
            - -1000
          default: 1823
        tick_upper:
          type: integer
          maximum: 887272
          minimum: -887272
          title: Tick Upper
          description: The upper tick of the range to mint the position in
          examples:
            - 1000
          default: 2623
        amount0_desired:
          anyOf:
            - type: number
              minimum: 0
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Amount0 Desired
          description: The desired amount of the first token to deposit
          examples:
            - '1.5'
          default: '0.05'
        amount1_desired:
          anyOf:
            - type: number
              minimum: 0
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Amount1 Desired
          description: The desired amount of the second token to deposit
          examples:
            - '1.7'
          default: '0.00'
        amount0_min:
          anyOf:
            - type: number
              minimum: 0
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Amount0 Min
          description: The minimum amount of the first token to deposit
          examples:
            - '1.4'
          default: '0'
        amount1_min:
          anyOf:
            - type: number
              minimum: 0
            - type: string
              pattern: ^(?!^[-+.]*$)[+-]?0*\d*\.?\d*$
          title: Amount1 Min
          description: The minimum amount of the second token to deposit
          examples:
            - '1.6'
          default: '0'
        recipient:
          anyOf:
            - type: string
            - type: 'null'
          title: Recipient
          description: The address that will receive the LP tokens
          examples:
            - '0x29F20a192328eF1aD35e1564aBFf4Be9C5ce5f7B'
          default: '0x41096de529D54718a5600185F8C4460979ed75C9'
        chain:
          type: string
          enum:
            - arbitrum
            - base
            - ethereum
          title: Chain
          default: base
          examples:
            - base
        sender:
          type: string
          title: Sender
          description: The address of the transaction sender.
          examples:
            - '0x29F20a192328eF1aD35e1564aBFf4Be9C5ce5f7B'
          default: '0x41096de529D54718a5600185F8C4460979ed75C9'
        estimate_gas:
          type: boolean
          title: Estimate Gas
          description: >-
            Determines whether to estimate gas costs for transactions, also
            verifying that the transaction can be successfully executed.
          default: true
      type: object
      required:
        - token0
        - token1
        - fee
        - tick_lower
        - tick_upper
        - amount0_desired
        - amount1_desired
        - amount0_min
        - amount1_min
        - chain
        - sender
      title: UniswapMintLiquidityProvisionRequest
      description: Request model for minting a new liquidity position.
      default:
        chain: base
        sender: '0x41096de529D54718a5600185F8C4460979ed75C9'
        token0: USDC
        token1: USDT
        fee: '1.0'
        tick_lower: 1823
        tick_upper: 2623
        amount0_desired: '0.05'
        amount1_desired: '0.00'
        amount0_min: '0'
        amount1_min: '0'
        recipient: '0x41096de529D54718a5600185F8C4460979ed75C9'
      required_allowances:
        - UniswapV3NFTPositionManager
    TransactionResponse:
      properties:
        transaction:
          anyOf:
            - $ref: '#/components/schemas/UnsignedTransaction'
            - $ref: '#/components/schemas/UserOperationResponse'
          title: Transaction
          description: >-
            The unsigned transaction data. User must sign and broadcast to
            network.
      type: object
      required:
        - transaction
      title: TransactionResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    FeeEnum:
      type: string
      enum:
        - '0.01'
        - '0.05'
        - '0.3'
        - '1.0'
      title: FeeEnum
      description: |-
        The transaction fee of a Uniswap pool in bips.

        Uniswap supports 4 different fee levels.
    UnsignedTransaction:
      properties:
        chainId:
          type: string
          title: Chainid
          description: The chain id of the transaction
        data:
          type: string
          title: Data
          description: The data of the transaction
        from:
          type: string
          title: From
          description: The sender of the transaction
        gas:
          anyOf:
            - type: string
            - type: 'null'
          title: Gas
          description: The gas of the transaction
        to:
          type: string
          title: To
          description: The recipient of the transaction
        value:
          type: string
          title: Value
          description: The value of the transaction
        nonce:
          type: string
          title: Nonce
          description: The nonce of the address
        maxFeePerGas:
          type: string
          title: Maxfeepergas
          description: The max fee per gas of the transaction
        maxPriorityFeePerGas:
          type: string
          title: Maxpriorityfeepergas
          description: The max priority fee per gas of the transaction
      type: object
      required:
        - chainId
        - data
        - from
        - gas
        - to
        - value
        - nonce
        - maxFeePerGas
        - maxPriorityFeePerGas
      title: UnsignedTransaction
      example:
        chainId: '0x2105'
        data: >-
          0x1688f0b900000000000000000000000029fcb43b46531bca003ddc8fcb67ffe91900c762000000000000000000000000000000000000000000000000000000000000006000000000000000000000000000000000000000000000000000000000675f4a3d
        from: '0x4A83b4413CF41C3244027e1590E35a0F48403F0c'
        gas: '0x7a120'
        maxFeePerGas: '0x59682f00'
        maxPriorityFeePerGas: '0x3b9aca00'
        nonce: '0x5'
        to: '0x4e1DCf7AD4e460CfD30791CCC4F9c8a4f820ec67'
        value: '0x0'
    UserOperationResponse:
      properties:
        to:
          type: string
          title: To
          description: The target contract address for the operation
        data:
          type: string
          title: Data
          description: The calldata for the operation
        value:
          type: string
          title: Value
          description: The ETH value to send with the operation
      type: object
      required:
        - to
        - data
        - value
      title: UserOperationResponse
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    ApiKeyAuth:
      type: apiKey
      in: header
      name: x-api-key
      description: >-
        Your Compass API Key. Get your key
        [here](https://www.compasslabs.ai/dashboard).

````